const WIDTH  = 15;
const HEIGHT = 5;

function PosToX(pos) {
	return {
		x: pos % WIDTH,
		y: Math.floor(pos / WIDTH)
	};
}

function GetScreen() {
	return document.getElementById("screen").innerHTML.replaceAll("<br>", "");
}

let running = false;

let playerPos = PosToX(GetScreen().indexOf("@"));

function GoLeft() {
	document.getElementById("left").click();
	playerPos.x -= 1;
}

function GoRight() {
	document.getElementById("right").click();
	playerPos.x += 1;
}

function GoUp() {
	document.getElementById("up").click();
	playerPos.y -= 1;
}

function GoDown() {
	document.getElementById("down").click();
	playerPos.y += 1;
}

let reset = false;

function Move() {
	if (running) return;

	running = true;

	let screen = GetScreen();

	let foodPos = PosToX(screen.indexOf("+"));
	let bombPos = PosToX(screen.indexOf("*"));

	let moved = false;

	if (playerPos.x > foodPos.x) { // player is on the right
		if ((bombPos.y == playerPos.y) && (bombPos.x == playerPos.x - 1)) {
			if (foodPos.y > playerPos.y) {
				GoDown();
			}
			else {
				GoUp();
			}
		}

		GoLeft();
		moved = true;
	}
	else if (playerPos.x < foodPos.x) { // player is on the left
		if ((bombPos.y == playerPos.y) && (bombPos.x == playerPos.x + 1)) {
			if (foodPos.y > playerPos.y) {
				GoDown();
			}
			else {
				GoUp();
			}
		}

		GoRight();
		moved = true;
	}
	else if (playerPos.y > foodPos.y) { // player is below
		if ((bombPos.x == playerPos.x) && (bombPos.y == playerPos.y - 1)) {
			if (foodPos.x > playerPos.x) {
				GoRight();
			}
			else {
				GoLeft();
			}
		}

		GoUp();
		moved = true;
	}
	else if (playerPos.y < foodPos.y) { // player is above
		if ((bombPos.x == playerPos.x) && (bombPos.y == playerPos.y + 1)) {
			if (foodPos.x > playerPos.x) {
				GoRight();
			}
			else {
				GoLeft();
			}
		}

		GoDown();
		moved = true;
	}

	running = false;
}

window.setInterval(Move, 20);
// window.setInterval(Move, 100);

window.setInterval(function() {
	while (running) {}

	running = true;

	playerPos = PosToX(GetScreen().indexOf("@"));

	running = false;
}, 1000);

document.addEventListener("keydown", function(e) {
	console.log("key");
	if (e.keyCode == 38) {
		GoUp();
	}
	else if (e.keyCode == 40) {
		GoDown();
	}
	else if (e.keyCode == 37) {
		GoLeft();
	}
	else if (e.keyCode == 39) {
		GoRight();
	}
});
